package SimExport;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.GregorianCalendar;

public class Export {

	// constructor
	public Export() {
	}

	// calculations for txt and csv files
	public String[][] fetchFile(String filepath) throws IOException {
		BufferedReader lecteurAvecBuffer = null;
		//	String ligne;

		try {
			lecteurAvecBuffer = new BufferedReader(new FileReader(filepath));
		} catch (FileNotFoundException exc) {
			System.out.println("File not Found");
		}
		int numberOfRows=getNumberRows(filepath);
		int numberOfColumns=getNumberColumns(filepath);
		String[][] tab2 = new String[numberOfRows+1][numberOfColumns*4+2];
		tab2[0][0]="Taxon";
		for (int i=1;i<=tab2[0].length/2;i++){
			if(i<=numberOfColumns)
				tab2[0][i]="X"+i;
			else if(i>numberOfColumns && i!=tab2[0].length/2)
				tab2[0][i]="Y"+(i-numberOfColumns);
			else
				tab2[0][i]="Node";
		}
		for (int i=tab2[0].length/2+1;i<tab2[0].length;i++){
			if(i<numberOfColumns*3+2)
				tab2[0][i]="X"+(i-2*numberOfColumns-1);
			else 
				tab2[0][i]="Y"+(i-3*numberOfColumns-1);

		}
		//	int k = 0;
		String temp=lecteurAvecBuffer.readLine();
		while (temp != null && !temp.contains("Trait values from")) {
			temp = lecteurAvecBuffer.readLine();
		}
		temp = lecteurAvecBuffer.readLine();
		temp = lecteurAvecBuffer.readLine();
		temp = lecteurAvecBuffer.readLine();

		for (int i=0;i<numberOfColumns;i++){

			for (int j=0;j<numberOfRows;j++){
				temp = lecteurAvecBuffer.readLine();
				String tab[]=temp.split(" +");
				tab2[j+1][0]=tab[0];
				tab2[j+1][i+1]=tab[1];
				tab2[j+1][i+numberOfColumns+1]=tab[2];
				tab2[j+1][numberOfColumns*2+1]=tab[3];
				tab2[j+1][i+numberOfColumns*2+2]=tab[4];
				tab2[j+1][i+numberOfColumns*3+2]=tab[5];
			}
		}
		lecteurAvecBuffer.close();

		return tab2;


		//
		/*setDataHeaders(getDataHeaderstxt(tab2));
		setDataX(getDataXtxt(tab2));
		setDataY(getDataYtxt(tab2));*/

	}
	public boolean ExportSim(String[][] tab2,String filepath){
		boolean ok=false;
		String tabDelimiter="\t";
		String lineDelimiter="\n";
		if (tab2[0].length<=256){
			StringBuffer output=new StringBuffer(20*tab2.length*tab2[0].length);
			for (int i=0;i<tab2.length;i++){
				for (int j=0;j<tab2[0].length;j++){
					output.append(tab2[i][j]);
					output.append(tabDelimiter);
				}
				output.append(lineDelimiter);
			}
			try {
				String out=output.toString();
				File file=new File(filepath+".xls");
				FileWriter outputFile=null;
				if(file.exists()){
					for(int i=1;i<=10;i++){
						File file1=new File(filepath+"("+i+").xls");
						if(!file1.exists()){
							outputFile=new FileWriter(filepath+"("+i+").xls");
							break;
						}
					}
				}
				if(outputFile==null)
					outputFile=new FileWriter(filepath+".xls");
				outputFile.write(out);
				outputFile.flush();
				outputFile.close();
				ok=true;
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		else{
			int rows=tab2.length;
			int numberOfTraits=(tab2[0].length-2)/4;
			int numberOfOutputFiles=numberOfTraits/63;
			int numbersOfSimulationLeft=numberOfTraits%63;
			String [] headers=new String [rows];
			String [][] firstX=new String [rows][numberOfTraits];
			String [][] secondX=new String [rows][numberOfTraits];
			String [][] firstY=new String [rows][numberOfTraits];
			String [][] secondY=new String [rows][numberOfTraits];
			String [] nodes=new String[rows];
			//fill the headers and nodes
			for (int i=0;i< rows;i++){
				headers[i]=tab2[i][0];
				nodes[i]=tab2[i][numberOfTraits*2+1];
			}
			//fill the X and Y arrays
			for(int i=0;i<rows;i++){
				for(int j=1;j<=numberOfTraits;j++){
					firstX[i][j-1]=tab2[i][j];
					firstY[i][j-1]=tab2[i][j+numberOfTraits];
					secondX[i][j-1]=tab2[i][j+2*numberOfTraits+1];
					secondY[i][j-1]=tab2[i][j+3*numberOfTraits+1];
				}
			}	
			//create output files
			for (int i=0;i<numberOfOutputFiles;i++){
				String [][] result=new String [rows][254];
				//fill headers and nodes into result
				for(int j=0;j<rows;j++){
					result[j][0]=headers[j];
					result[j][127]=nodes[j];
				}
				/**fill data into results**/
				/*for(int k=0;k<rows;k++){
					for(int j=0+63*i;j<63+63*i;j++){
						result[k][j+1-63*i]=firstX[k][j];
					}
					for(int j=63+63*i;j<126+63*i;j++){
						result[k][j+1-63*i]=firstY[k][j-63];
					}
					for(int j=127+63*i;j<190+63*i;j++){
						result[k][j+1-63*i]=secondX[k][j-127];
					}
					for(int j=190+63*i;j<253+63*i;j++){
						result[k][j+1-63*i]=secondY[k][j-190];
					}
				}*/
				for(int k=0;k<rows;k++){
					for(int j=0+63*i;j<63+63*i;j++){
						result[k][j+1-63*i]=firstX[k][j];
						result[k][j+1+63-63*i]=firstY[k][j];
						result[k][j+1+127-63*i]=secondX[k][j];
						result[k][j+1+190-63*i]=secondY[k][j];
					}
				}
				try {
					StringBuffer output=new StringBuffer(20*rows*254);
					for (int l=0;l<rows;l++){
						for (int j=0;j<254;j++){
							output.append(result[l][j]);
							output.append(tabDelimiter);
						}
						output.append(lineDelimiter);
					}
					String out=output.toString();
					File file=new File(filepath+"part"+i+".xls");
					FileWriter outputFile=null;
					if(file.exists()){
						for(int m=1;m<=256;m++){
							File file1=new File(filepath+"part"+i+"("+m+").xls");
							if(!file1.exists()){
								outputFile=new FileWriter(filepath+"part"+i+"("+m+").xls");
								break;
							}
						}
					}
					if(outputFile==null)
						outputFile=new FileWriter(filepath+"part"+i+".xls");
					outputFile.write(out);
					outputFile.flush();
					outputFile.close();
					ok=true;
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			//create output file for last simulations
			String [][] result=new String [rows][numbersOfSimulationLeft*4+2];
			//fill headers and nodes into result
			for(int j=0;j<rows;j++){
				result[j][0]=headers[j];
				result[j][result[0].length/2]=nodes[j];
			}
			//fill data into results
			for(int k=0;k<rows;k++){
				for(int j=numberOfTraits-numbersOfSimulationLeft;j<numberOfTraits;j++){
					result[k][j+1-numberOfTraits+numbersOfSimulationLeft]=firstX[k][j];
					result[k][j+1-numberOfTraits+numbersOfSimulationLeft*2]=firstY[k][j];
					result[k][j+1-numberOfTraits+numbersOfSimulationLeft*3+1]=secondX[k][j];
					result[k][j+1-numberOfTraits+numbersOfSimulationLeft*4+1]=secondY[k][j];
				}
			}
			try {
				StringBuffer output=new StringBuffer(20*rows*result[0].length);
				for (int l=0;l<rows;l++){
					for (int j=0;j<result[0].length;j++){
						output.append(result[l][j]);
						output.append(tabDelimiter);
					}
					output.append(lineDelimiter);
				}
				String out=output.toString();
				File file=new File(filepath+"part"+numberOfOutputFiles+"(last).xls");
				FileWriter outputFile=null;
				if(file.exists()){
					for(int m=1;m<=256;m++){
						File file1=new File(filepath+"part"+numberOfOutputFiles+"("+m+")(last).xls");
						if(!file1.exists()){
							outputFile=new FileWriter(filepath+"part"+numberOfOutputFiles+"("+m+")(last).xls");
							break;
						}
					}
				}
				if(outputFile==null)
					outputFile=new FileWriter(filepath+"part"+numberOfOutputFiles+"(last).xls");
				outputFile.write(out);
				outputFile.flush();
				outputFile.close();
				ok=true;
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return ok;
	}
	// return the number of rows
	public int getNumberRows(String file) throws IOException {
		BufferedReader lecteurAvecBuffer = new BufferedReader((new FileReader(
				file)));
		String temp=lecteurAvecBuffer.readLine();
		while (temp!=null && !temp.contains("Number of Tips")){
			temp=lecteurAvecBuffer.readLine();
		}
		String tab[]=temp.split(" +");
		lecteurAvecBuffer.close();
		return Integer.parseInt(tab[5]);
	}

	// return the number of columns
	public int getNumberColumns(String file) throws IOException {
		BufferedReader lecteurAvecBuffer = new BufferedReader((new FileReader(
				file)));
		String temp = lecteurAvecBuffer.readLine();
		while (temp!=null && !temp.contains("Trait values from")){
			temp=lecteurAvecBuffer.readLine();
		}
		String tab[]=temp.split(" +");
		lecteurAvecBuffer.close();
		int rows=0;
		rows=Integer.parseInt(tab[3]);
		return rows;
	}
}
