package SimExport;

import java.awt.Color;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.io.File;
import java.util.List;

import javax.swing.JComponent;
import javax.swing.TransferHandler;

//adadpted to java 1.4 from the example of the website
class MyTransferHandler extends TransferHandler {
	private InterfaceSimExport IR;

	public MyTransferHandler(InterfaceSimExport ir) {
		this.IR = ir;
	}

	public boolean canImport(JComponent comp, DataFlavor[] flavors) {
		DataFlavor flavor = null;
		for (int i = 0; i < flavors.length; i++) {
			flavor = flavors[i];
			if (flavor.equals(DataFlavor.javaFileListFlavor))
				return true;
		}

		return false;
	}

	/**
	 * 32: * Handle a drop by displaying the list of file names in the textArea.
	 * 33: * 34: *
	 * 
	 * @param comp
	 *            Component receiving the drop 35: *
	 * @param t
	 *            The drop object 36: *
	 * @return true if the drop was handled 37:
	 */
	// @Override
	public boolean importData(JComponent comp, Transferable t) {
		IR.getTextField().setText("");
		try {
			// note: apparently this Java method hasn't been updated for
			// generics,
			// a warning of unchecked cast will be indicated at compile time

			List list = (List) t.getTransferData(DataFlavor.javaFileListFlavor);
			// get the list of the dragg and dropped files into the textfield
			for (int i = 0; i < list.size(); i++) {
				File f = (File) list.get(i);
				String filename = f.getAbsolutePath();
				// checks if the file is supported
				if (!filename.endsWith(".sim") && !filename.endsWith(".SIM")) {
					IR.getTextField().setForeground(Color.RED);
					IR.getTextField().setText("This file isn't supported !");
				} else {// if yes run calculations
				//	IR.getFrame().setVisible(false);
				//	IR.getTextField().setText(filename);
					Export SimExport=new Export();
					SimExport.ExportSim(SimExport.fetchFile(filename),filename);
					IR.getTextField().setForeground(Color.BLACK);
					IR.getTextField().setText("Welcome to SimExporter");
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			IR.getTextField().setForeground(Color.RED);
			IR.getTextField().setText("Error occured while exporting!");
			return false;
		}
		
		return true;
	}
}
